<script setup lang="ts">
// Composables
import { usePaginatedList } from '~/composables/usePaginatedList'

// Handlers
import type { ToastFn } from '~/handlers/_handler'

// Pubs component
import { toast } from '~/components/pub/ui/toast'
import { ActionEvents, type HeaderPrep } from '~/components/pub/my-ui/data/types'
import Header from '~/components/pub/my-ui/nav-header/prep.vue'
import RecordConfirmation from '~/components/pub/my-ui/confirmation/record-confirmation.vue'

// Order
import {
  recId,
  recAction,
  recItem,
  isRecordConfirmationOpen,
  handleActionRemove,
} from '~/handlers/procedure-room-order.handler'
import { getList, create, submit } from '~/services/procedure-room-order.service'
import type { ProcedureRoomOrder } from '~/models/procedure-room-order'
import List from '~/components/app/procedure-room-order/list.vue'

// Common prep
const route = useRoute()
const { setQueryParams } = useQueryParam()
const { crudQueryParams } = useQueryCRUD()

const plainEid = route.params.id
const encounter_id = (plainEid && typeof plainEid == 'string') ? parseInt(plainEid) : 0
const isSubmitConfirmationOpen = ref(false)

// Main data
const {
  data,
  isLoading,
  paginationMeta,
  searchInput,
  fetchData: getMyList,
} = usePaginatedList<ProcedureRoomOrder>({
  fetchFn: async (params: any) => {
    const result = await getList({
      'encounter-id': encounter_id,
      includes: 'items',
      search: params.search,
      page: params.page,
      'page-number': params['page-number'] || 0,
      'page-size': params['page-size'] || 10,
    })
    return { success: result.success || false, body: result.body || {} }
  },
  entityName: 'prescription'
})

// Header things
const headerPrep: HeaderPrep = {
  title: 'Order Ruang Tindakan',
  icon: 'i-lucide-box',
  refSearchNav: {
    placeholder: 'Cari (min. 3 karakter)...',
    minLength: 3,
    debounceMs: 500,
    showValidationFeedback: true,
    onInput: (value: string) => {
      searchInput.value = value
    },
    onClick: () => {},
    onClear: () => {},
  },
  addNav: {
    label: 'Tambah',
    icon: 'i-lucide-plus',
    onClick: async () => {
      recItem.value = null
      recId.value = 0
      const res = await create({ encounter_id })
      if (res.success) {
        crudQueryParams.value = { mode: 'entry', recordId: res.body?.data.id.toString() || '0' }
      }
    },
  },
}

// list actions
const timestamp = ref<any>({})
provide('rec_id', recId)
provide('rec_action', recAction)
provide('rec_item', recItem)
provide('table_data_loader', isLoading)
provide('timestamp', timestamp)
watch(recAction, () => {
  if (!recAction.value) {
    return
  } else if (recAction.value === ActionEvents.showDetail) {
    crudQueryParams.value = { mode: 'entry', recordId: recId.value || '0' }
  } else if (recAction.value === ActionEvents.showConfirmSubmit) {
    isSubmitConfirmationOpen.value = true
  } else if (recAction.value === ActionEvents.showConfirmDelete) {
    isRecordConfirmationOpen.value = true
  }
  recAction.value = ''
})

///// functions

function confirmCancel(data: ProcedureRoomOrder) {
  recId.value = data.id
  recItem.value = data
  isRecordConfirmationOpen.value = true
}

function goToEdit(data: ProcedureRoomOrder) {
  setQueryParams({
    'mode': 'entry',
    'id': data.id.toString()
  })
  recItem.value = data
}

function confirmSubmit(data: ProcedureRoomOrder) {
  recId.value = data.id
  recItem.value = data
  isSubmitConfirmationOpen.value = true
}

async function handleActionSubmit(id: number, refresh: () => void, toast: ToastFn) {
  const result = await submit(id)
  if (result.success) {
    toast({ title: 'Berhasil', description: 'Resep telah di ajukan', variant: 'default' })
    setTimeout(refresh, 300)
  } else {
    toast({ title: 'Gagal', description: 'Gagal menjalankan perintah', variant: 'destructive' })
  }
}
</script>

<template>
  <Header :prep="{ ...headerPrep }" />

  <List
    v-if="!isLoading.dataListLoading"
    :data="data"
    :pagination-meta="paginationMeta"
    @cancel="confirmCancel"
    @edit="goToEdit"
    @submit="confirmSubmit"
  />

  <RecordConfirmation
    v-model:open="isRecordConfirmationOpen"
    action="delete"
    :record="recItem"
    @confirm="() => handleActionRemove(recId, getMyList, toast)"
    @cancel=""
  >
    <div class="flex mb-2">
      <div class="w-20">Tanggal</div>
      <div class="w-4">:</div>
      <div class="">{{ recItem.createdAt?.substring(0, 10) }}</div>
    </div>
    <div class="flex">
      <div class="w-20">DPJP</div>
      <div class="w-4">:</div>
      <div class="">{{ recItem.doctor?.employee?.person?.name }}</div>
    </div>
  </RecordConfirmation>

  <RecordConfirmation
    v-model:open="isSubmitConfirmationOpen"
    action="delete"
    customTitle="Ajukan Resep"
    customMessage="Proses akan mengajukan resep ini untuk diproses lebih lanjut. Lanjutkan?"
    customConfirmText="Ajukan"
    :record="recItem"
    @confirm="() => handleActionSubmit(recId, getMyList, toast)"
    @cancel=""
  >
    <div class="flex mb-2">
      <div class="w-20">Tanggal</div>
      <div class="w-4">:</div>
      <div class="">{{ recItem.createdAt.substring(0, 10) }}</div>
    </div>
    <div class="flex">
      <div class="w-20">DPJP</div>
      <div class="w-4">:</div>
      <div class="">{{ recItem.doctor?.employee?.person?.name }}</div>
    </div>
  </RecordConfirmation>
</template>
